// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//  Giuseppe Vacanti (cosine science & computing bv)
//  August 18, 2003
// 
//   $Id: NonPeriodicHkTest.cc,v 1.1 2003/08/26 15:22:31 gvacanti Exp $

#include<SmartDal>
#include<iostream>
#include<STime.h>
#include<TimeRows.h>
#include<cassert>

int main() {
  using namespace SmartDal;
  DataSetH set = open_set("0153_0129360201_M1X00000HCH.FIT", Read, Low);
  TableH table = set->table(0);
  TimeRows tr(table);
  STime st("2000-10-10T01:34:58");
  std::pair<long, long> p = tr.active_range(st);
  std::cout << "Active range for " << st.toString() << std::endl;
  std::cout << p.first << " " << p.second << std::endl;
  assert(p.first == 0 && p.second == 8);
}
